Show Posts

This section allows you to view all posts made by this member. Note that you can only see posts made in areas you currently have access to.


Messages - Carl

Pages: [1] 2
1
Firefox works just fine for me on my Mac. Stick with Opera (or Chrome?) if they work... this kind of troubleshooting tends to be pretty hard in my experience.

2
Cartographers / Re: Most popular time to play?
« on: 29/12/20, 05:12pm »
I am often online in PST evenings. I don't play as much anymore (200+ games already), and I prefer fast games (~8-10 minutes). But if I'm online, you can DM me.

3
Cartographers / Re: Best Great City
« on: 09/12/20, 07:07am »
I recently got my web UI working. 78 is possible like I suspected, and relies on blocking but not covering one of the ruin spaces.

Typing this made me realize 79 is possible as well, but I'll leave that as an exercise for the reader :)

4
Cartographers / Re: Best Great City
« on: 26/11/20, 09:45pm »
Yes, I wrote a simulator and simple AI for Cartographers as a hobby project. It can play a decent game against itself, and soon I'm hoping that I'll be able to play against it as well. It probably will never be released, although I'm exploring the possibility to release some part of it. Maybe it will encourage Happy Meeple to offer an AI opponent here too :)

Unbalancing the draws is relatively easy compared to writing the simulator. If you know about the board game, the deck consists of 17 cards: a single square, 10 regular pieces, 2 ruins, and 4 monsters. In this case, I just kept all 5 pieces that have red on them and the piece which is only yellow for the simulation. I drew cards from that deck following the standard rules.

I put Great City last among the scoring cards, and randomized the other scoring cards to see how high it would score against itself.

5
Cartographers / Re: Best Great City
« on: 26/11/20, 03:49am »
I gave my simulator a few unbalanced draws and 68 is one of the highest scores so far. The theoretical max is pretty tricky, because there are only 19 red squares (did I do the math right?) in the deck for 19x4 = 76. I guess the other draws need to come from single red squares which is pretty hard, since you cannot easily cover up the ruins next to the mountains.

Since the 4 pieces with red on them already take up 7 time in each season, you will have spent 5 time after 3 pieces, and therefore only have room for 2 other pieces in the first season, and 1 additional piece in seasons 2 and 3 (each converted to a single red square through a ruin). That would make the theoretical max 80. I can't easily see how you can block all the ruins to accomplish this especially in season 1, so I think the theoretical max may be about 78.

6
Cartographers / Time controls
« on: 23/11/20, 04:50pm »
I have found that my games often take longer than I'd like. I'm not sure if it's because people want to play more carefully against me because of my rating, or if it's just because I'm a fast player in general (or both).

I feel that the best way to improve this would be to adjust the time control. Here are my best suggestions so far:

  • Fixed time per player for the whole game (6-10 minutes default)
  • Fixed time per player with additional time per move (e.g. 3 minutes per game and first 15 seconds per move are 'free')
  • Shorter fixed time per move (e.g. 30 secs or 1 minute) with a small reserve for the whole game to avoid time outs

For reference, my sweet spot in terms of game length would be just short of 10 minutes. Currently, most games fall in 10-15 minute range and some of the slower one run to about 20 minutes.

Sadly I realize this may fall below the line since it is mostly important for competitive play, but I think it would make competitive play more fun.

7
Cartographers / Re: A small way to make bots smarter.
« on: 23/11/20, 12:40am »
It's probably just a matter of prioritization for the developer(s). They may have thought that it is harder to write an AI than it is.

I wrote an AI, and getting it to intermediate level is pretty easy. It's using a greedy algorithm, which is neither computationally expensive nor hard to code up. Getting it to 'advanced' level, especially with certain scoring cards (Lost Barony, Shieldgate etc.), is probably pretty tricky.

8
Cartographers / Re: Cartographers simulation v0
« on: 14/11/20, 06:28am »
I'm not sure exactly what the question is. There is a basic problem of how to identify clusters and neighbors of clusters on the board. A lot of scoring cards require that and luckily it is not that hard to identify the groups on the board.

There are simple examples here: https://www.hackerrank.com/challenges/connected-cell-in-a-grid/problem or here: https://medium.com/analytics-vidhya/number-of-islands-day-5-python-5c12783515b2. I prefer a version that counts the cells and does not alter the grid. Once you have identified the groups it's easy to identify their neighbors.

If you want to get fancier I think you can keep track of only changes in groups as new tiles are placed but I didn't do this.

Another more interesting question for an AI is how to score village cells that are not yet next to three other cells. I do this with a partial score for such clusters (e.g. 1p for being next to 2 types of terrain instead of 0). It helps the AI to look for moves that are more likely to be promising. It's quite time-consuming to test these parameters, and that's one reason why rule-based methods are not so popular, but at least it is easy to make a first attempt.

Happy to try to answer if you have more specific questions.

9
HexRoller / Re: HexRoller under construction?
« on: 12/11/20, 05:54am »
One of my favorites too. Fun push your luck element but also a fair bit of luck. :)

10
Cartographers / Re: Cartographers simulation v0
« on: 09/11/20, 10:42pm »
I now have a working simulation of the whole game with most rules incorporated, and most score cards from base game and heroes.

https://imgur.com/a/SjkT58p - shows the same draw of cards with and without monsters, with the same score cards and a greedy vs greedy + tweaks algorithm (some minor tweaks to make progress toward Borderlands/Wildholds in greedy strategy).

I'm showing the best of 10 plays for each layout with that strategy.

  • Greedy, no monsters 116p (avg 106, std 6.7)
  • Greedy w tweaks, no monsters 153p (avg 135, std 7.7)
  • Greedy, 2 monsters 97p (avg 91, std 4.7)
  • Greedy w tweaks, 2 monsters 122p (avg 107, std 7.3)


11
Cartographers / Re: Cartographers simulation v0
« on: 08/11/20, 02:57pm »
Updated descriptions. It picks the best move that maximizes 'long-term score', based on all the edicts coming up to score (but not taking into account when they are scored). In this case, since all edicts are scored at the end, the scoring function is simply the sum of all edict scores used.

Of course it has the obvious drawback that edicts that require 'planning', e.g. Wildholds, Borderlands, are probably not played anywhere close to optimally. The edicts which rely on short-term score and are not severely constrained (e.g. Canal Lake) are probably played pretty the best.

Given that it seems to lead to reasonable play, my idea is that it would be possible to feed these games into a policy network to create a deep (or shallow) learning engine which should play significantly better. But I'm not exactly sure how to do it so not committed yet :)

12
Cartographers / Cartographers simulation v0
« on: 08/11/20, 07:14am »
I created a small script to simulate Cartographers games using a greedy algorithm. Currently, it only scores the game once, at the end of the game, and it does not take into account points for Coins (either from mountains or pieces). There are also no monsters.

https://imgur.com/a/sEg4rYW

I'm 'cheating' a little bit here, because I'm taking the best of 10 plays for a particular set of cards. However, there is no learning going across games (i.e. the simulator doesn't make use of what cards will come up later in the game).

Hopefully if I keep going there will be more interesting updates later. :)

13
Cartographers / Re: On Filling every single space
« on: 03/11/20, 04:38am »
Yes :)

No :)

Somewhat more seriously, the tiles have in order 1 / 5 5 5 4 / 5 5 5 4 4 4 squares starting from the most time efficient cards.

So with 8 7 7 6 time in the seasons you could get 30, 25, 25, 25 squares filled in = 105 total. With 4 monsters, you're up to 121, exactly filling an 11x11 board without the holes/mountains.

I may have got the math wrong, I did it quickly in my head. But it seems reasonable enough.

The board without wastelands has 116 spaces, and with wastelands 109 spaces. So it's probably (pretty surely) theoretically possible to fill both of them with the right luck with the monsters.

If there had been edicts that encourage trying a bit harder someone might get close, but with monsters in play it is unlikely.

14
Happy Meeple community / Re: Feature requests
« on: 30/10/20, 02:56pm »
In games that 'should' be fast, like Lost Cities and Finito, there is a tiny minority of players who tend to play really slowly.I would LOVE the opportunity either to click 'never match me with this player again' or to choose between 'fast' and 'slow' play when opening a table (e.g. 1 min per turn/2 mins per turn, or better still a total time allowed for all of each player's moves).

This applies for Cartographers as well. It would be nice to agree on a single standard time setting. E.g. 30 seconds per move + 2 mins reserve time for whole game, or 10 minutes for the whole game. I think having a base time per move helps since it will make time-outs less likely.

15
Cartographers / Re: Strategy question single squares
« on: 25/10/20, 03:02pm »
Yes, there are a few occasions. The most obvious ones is if you want to use a single monster square to improve the score for Greengold Plains (it's still unusual since you usually have other color options as well). In the base game, it's the only possibility I think since you always have the choice of Green to not risk losing any points (both Red and Blue/Yellow can lose points with a few scoring cards).

Pages: [1] 2